function triSolve(AFileName, UFileName, LFileName)
% read in a compressed matrix
% multiply it by a vector
% print the result

% read the A matrix
[A, rows, cols, entries] = mmread(AFileName); 

format long
disp('A')
disp(A)

[L,U,P] = lu(A);

disp('L')
disp(full(L))

disp('U')
disp(full(U))

% write the upper triangular matrix
mmwrite(UFileName,U,'upper triangular','real')

% write the lower triangular matrix
mmwrite(LFileName,L,'lower triangular','real')
