function randomSubMatrix(height, width, fileName1, fileName2)
% create a matrix with <height>*<width> entries containing random doubles
% save it to a file named <fileName1>
% save the submatrix to <fileName2>

format long

% zero-out the matrix
m = [zeros(height,width)];

% create a sub-matrix in the center
n = [randn(height/2,width/2)];
m(height/4+1:3*height/4,width/4+1:3*width/4) = n;

f1 = fopen(fileName1,'w');
fprintf(f1,'%d %d\n',height,width);
fprintf(f1,'%f\n',m);
fclose(f1);


f2 = fopen(fileName2,'w');
fprintf(f2,'%d %d\n',height/2,width/2);
fprintf(f2,'%f\n',n);
fclose(f2);

