#ifndef DCOO_H
#define DCOO_H
#define DCOO SPBLASI_double_COO

enum blas_base_type { blas_zero_base = 0, blas_one_base = 1};
enum blas_trans_type { blas_trans = 10, blas_no_trans = 20};

typedef struct
{
	int M_, N_, nz_;
	int prop_;
	double *val_;
	int *i_;
	int *j_;
	int reclaim_space; 		/* boolean, true if mallocs own val, i, j */	
} *DCOO, DCOO_struct;


DCOO create_DCOO( int M, int N, int nz, double *val,
	int *indx, int *jndx, int properties);

DCOO create_DCOO_copy( int M, int N, int nz, double *val,
	int *indx, int *jndx, int properties);

void destroy_DCOO( DCOO A);

#endif



