#include <stdio.h>
#include "spblas.h"
#include "spblas_i.h"

DCSR DCOO_2_DCSR(DCOO A);


int main(int argc, char *argv[])
{
	DCOO A = NULL;
	DCSR B = NULL;

	int M = 5;
	int N = 5;
	int nz = 5;

	/*
	double val[] = { 1.1, 2.1, 3.1, 4.1, 5.1 };
	int I[]      = {   0,   1,   2,   3,   4 };
	int J[]      = {   0,   1,   2,   3,   4 };
	int prop = blas_zero_base;
	*/

	double val[] = { 1.1, 2.1, 3.1, 4.1, 5.1 };
	int I[]      = {   1,   2,   3,   4,   5 };
	int J[]      = {   1,   2,   3,   4,   5 };
	int prop = blas_one_base;

	A = create_DCOO(M, N, nz, val, I, J, prop); 
	DCOO_print(A);
	printf("\n\n");

	B = DCOO_2_DCSR(A);
	DCSR_print(B);

	return 0;
}


