import java.io.*;

public class CompRow {

  // the actual elements
  double[] val;
 
  // the column indices 
  int[] indx;

  // the row beginning points
  int[] pntrb;

  // the row end points
  int[] pntre;

  // dimensions of the array
  int height;
  int width;


  // init the compressed array
  public CompRow() {

    double[] temp_val = {11,13,14,23,24,31,32,33,34,42,44,51,52,55};
    int[] temp_indx = {0,2,3,2,3,0,1,2,3,1,3,0,1,4};
  
    int[] temp_pntrb = {0,3,5,9,11};
    int[] temp_pntre = {3,5,9,11,14};

    sourceArray = tempArray;

    val = temp_val;
    indx = temp_indx;
    pntrb = temp_pntrb;
    pntre = temp_pntre;

    height = 5;
    width = 5;
  }


  public void print() {
    
    for (int i = 0; i < height; i++) {
      for (int j = 0; j < width; j++) {
	System.out.print(sourceArray[i][j]+"    ");
      }
      System.out.println();
      System.out.println();
    }
  }


  public int getNumNonZero() {

    return val.length;

  }


  public static CompRow dense2Sparse() {
    
  }


  // multiply by a vector
  public double[] standardMult(double[] inVector) {
    double[] resultVector = new double[height];
    int temp;

    // standard matrix multiply     
    for (int i = 0; i < height; i++) {
      temp = 0;
      for (int j = 0; j < inVector.length; j++) {
	temp += inVector[j] * sourceArray[i][j];
      }
      resultVector[i] = temp;
    }
    return resultVector;
  }
  


  public double[] mult(double[] inVector) {
    
    double[] resultVector = new double[height];
    int temp;
    
    for (int rowNum = 0; rowNum < height; rowNum++) {
      for (int xindex = pntrb[rowNum]; xindex < pntre[rowNum]; xindex++) {
	// multiply the inVector by the array's row
	resultVector[rowNum] += (inVector[indx[xindex]] * val[xindex]);
      }
    }
    return resultVector;
  }



  public static void main(String[] args) {

    double[][] tempArray = {{11,0,13,14,0},{0,0,23,24,0},{31,32,33,34,0},{0,42,0,44,0},{51,52,0,0,55}};

    // do the standard multiplication by a vector
    double[] resultVect = foo.standardMult(myVect);
    for (int i = 0; i < resultVect.length; i++) {
      System.out.println(resultVect[i]);
    }

    System.out.println();

    // do a compressed multiplication
    double[] resultVect2 = foo.mult(myVect);
    for (int i = 0; i < resultVect2.length; i++) {
      System.out.println(resultVect2[i]);
    }
  }
}
