public class TestMult2 {

  public static void main(String[] args) {
    int M = 5;
    int N = 5;
    int nz = 5;
    double val[] = {2.0,2.0,2.0,2.0,2.0};
    int indx[] = {0,1,2,3,4};
    int jndx[] = {0,1,2,3,4};
    int properties = 0;
    int transpose = Jblas.NoTrans;
    int k = 5;
    double alpha = 1.0;
    double beta = 0.0;

    DCOO dc1 = new DCOO(M, N, nz, val, indx, jndx, properties); 

    dc1.print();

    double[][] B = {{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},
		    {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},
		    {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},
		    {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},
		    {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},
		    {0.0,0.0,0.0,0.0,0.0,2.0,2.0,2.0,2.0,2.0},
		    {0.0,0.0,0.0,0.0,0.0,2.0,2.0,2.0,2.0,2.0},
		    {0.0,0.0,0.0,0.0,0.0,2.0,2.0,2.0,2.0,2.0},
		    {0.0,0.0,0.0,0.0,0.0,2.0,2.0,2.0,2.0,2.0},
		    {0.0,0.0,0.0,0.0,0.0,2.0,2.0,2.0,2.0,2.0}};

    try {
      Dense.save(B, "out");
      B = Dense.read("out");
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    Dense.print(B);

    double[][] C = new double[10][10];
    Dense.arraySetToValue(C,0.0);
        
    dc1.dusmm(transpose, k, alpha, B,5,5, beta, C,2,2);

    Dense.print(C);
  
  }
}
