import java.util.*;
import java.io.*;
//import jnt.io.*;

public class Diagonal {

  double[] val;
  int[] idiag;

  int height;
  int width;
  int numNonZero;

  public Diagonal() {
  }

  public Diagonal(double[][] inVal, int[] inIdiag,int inHeight,int inWidth,int inNumNonZero) 
  {
    val = inVal;
    idiag = inIdiag;

    height = inHeight;
    width = inWidth;
    numNonZero = inNumNonZero;
  }

  public static Diagonal dense2Sparse(double[][] inArray) {

    Vector tempVal = new Vector();
    Vector tempCol = new Vector();
    Vector tempIdiag = new Vector();
     
    double[] valArray;
    int[] iindexArray;
    int[] jindexArray;

    int tempHeight = inArray.length;
    int tempWidth = inArray[0].length;
    
    for (int i = tempHeight - 1; i >= 0; i--) {
      for (int j = 0; j < tempWidth; j++) {
	if (inArray[i][j] != 0) { 
	}
      }
    }
    
    return (new Diagonal(valArray,iindexArray,jindexArray,tempHeight,tempWidth,tempNumNonZero));
  }


  public double[] mult(double[] inVector) {
    double[] resultVector = new double[height];

    for (int i = 0; i < numNonZero; i++) {
      resultVector[iindex[i]] += val[i] * inVector[jindex[i]];
    }
    
    return resultVector;
  }


  public void print() {

    System.out.println("Val:");
    for (int i = 0; i < val.length; i++) {
      System.out.print(val[i]+" ");
    }
    System.out.println();
    System.out.println();
    
    System.out.println("Iindex:");
    for (int i = 0; i < val.length; i++) {
      System.out.print(iindex[i]+ " ");
    }
    System.out.println();
    
    System.out.println("Jindex:");
    for (int i = 0; i < val.length; i++) {
      System.out.print(jindex[i]+ " ");
    }
    System.out.println();
  }


  public static void main(String[] args) {
    
    //double[][] tempArray = {{11,0,13,14,0},{0,0,23,24,0},{31,32,33,34,0},{0,42,0,44,0},{51,52,0,0,55}};
    double[] tempVect = {1,1,1,1,1};
    double[] outVect;
    Diagonal c1;

    try {

      NumericReader nr = new NumericReader( new FileReader("dense.dat"));
      int h1 = nr.readInt();
      int w1 = nr.readInt();

      // read the dense array
      double[][] tempArray = new double[h1][w1];

      for (int i = 0; i < h1 * w1; i++) {
	tempArray[(i / w1)] [(i % w1)] = nr.readDouble();
      }

      // print it
      for (int i = 0; i < tempArray.length; i++) {
	for (int j = 0; j < tempArray[0].length; j++) {
	  System.out.print(tempArray[i][j]+"  ");
	}
	System.out.println();
      }
      System.out.println();

      // convert the dense array to a sparse Diagonal array
      c1 = Diagonal.dense2Sparse(tempArray);
      c1.print();

      System.out.println();

      // multiply the compressed Diagonal array by the input
      outVect = c1.mult(tempVect);
    
      for (int i = 0; i < outVect.length; i++) {
	System.out.print(outVect[i]+ "  ");
      }
      System.out.println();
    }
  
    catch(Exception e) {
      e.printStackTrace();
    }
  }
}




