import java.util.*;

public class ArrayConverter {

  public ArrayConverter() {
    val = new Vector();
    iindex = new Vector();
    jindex = new Vector();
  }

  public CompressedCoordArray dense2CoordSparse(double[][] inArray) {
    
    Vector val, iindex, jindex;
    
    for (int i = 0; i < inArray.length; i++) {
      for (int j = 0; j < inArray[0].length; j++) {
	if (inArray[i][j] != 0){ 
	  val.addElement(new Double(inArray[i][j]));
	  iindex.addElement(new Integer(i));
	  jindex.addElement(new Integer(j));
	}
      }
    }

    double[] tempVal = new double[val.size()];
    int[] tempIindex = new int[iindex.size()];
    int[] tempJindex = new int[jindex.size()];
  
    for (int i = 0; i < val.size() ; i++) {
      tempVal[i] = ((Double) val.elementAt(i)).doubleValue();
    }
  
    for (int i = 0; i < iindex.size() ; i++) {
      tempIindex[i] = ((Integer) iindex.elementAt(i)).intValue();
    }
  
    for (int i = 0; i < jindex.size() ; i++) {
      tempJindex[i] = ((Integer) jindex.elementAt(i)).intValue();
    }
  
    return (new CompressedCoordArray(tempVal,tempIindex,tempJindex, iindex.size() , jindex.size()));
  }

  /*
  public CompressedRowArray dense2CRSparse(double [][] inArray) {

    Vector tempVal = new Vector();
    Vector tempIndx = new Vector();
    Vector tempPntrb = new Vector();
    Vector tempPntre = new Vector();
    int tempCounter = 0;

    // column loop
    for (int i = 0; i < inArray.length; i++) {
      tempPntrb.addElement(new Integer(tempCounter));
      
      // row loop
      for (int j = 0; j < inArray[0].length; j++) {
	if (inArray[i][j] != 0) {
	  tempVal.addElement(inArray[i][j]);
	  tempIndx.addElement(new Integer(j));
	  tempCounter++;
	}
      }      
    }
  }
  */

  /*
  public double[][] sparse2dense(CompressedCoordArray inArray) {
    double[][] outArray = new double[inArray.height][inArray.width];
        

    // loop through the compressed array and just 
    for (int i = 0; i < inArray.height; i++) {
      

    }

    return outArray;
  }
  */

  /*
  public CompressedRowArray dense2Sparse(double[][] inArray) {
  }

  public CompressedColArray dense2Sparse(double[][] inArray) {
  }

  public CompressedDiagArray dense2Sparse(double[][] inArray) {
  }
  */
}
