function triSolve(size, UFileName)

% generate an upper unitary matrix

m = size;
n = m;

%A = ones(m,n)
A = randn(m,n);

for i = 1:m
    for j = 1:n    
      if i > j 
         A(i,j) = 0;
      else if i == j
         A(i,j) = 1;
end
end
end
end

format long
disp('A')
disp(full(A))
disp('inv(A)')
disp(full(inv(A)))

% save A as matrix market
A = sparse(A);
% write the upper triangular matrix
mmwrite(UFileName,A,'upper triangular','real')


