#include <stdio.h>
#include <time.h>
#include <math.h>

int main(int argc, char *argv[])
{
  int i,j;
  /* use system clock time */
  clock_t start, stop, total;
  int iterations = 5000000;
  double total_time, average_time;

  /* start timing using the clock() function in time.h */
  start = clock();
  
  for (i = 0; i < iterations; i++) {
	for (j = 0; j < 10; j++)
		sqrt((double) j);
  }	
 
  /* stop timing */ 
  stop = clock();

  total = stop - start;
  printf("start: %d\n",(int)start);
  printf("stop: %d\n",(int)stop);
  printf("total: %d\n",total);
  printf("CLOCKS_PER_SEC: %d\n",CLOCKS_PER_SEC);
  
  total_time = (stop-start)/((double) CLOCKS_PER_SEC);
  printf("total_time = %f\n",total_time);
  average_time = total_time/iterations;
  printf("average_time = %f\n",average_time);
}
