
#ifndef MICROBLAS_H
#define MICROBLAS_H

#include "c_blas.h"


void ublas_spdotab(double alpha, int ibegin, int iend,
        const double *x, const int *ind, const double *y, int incy,
        double beta, double *r);


void ublas_spdaxpby(int N, int ibegin, int iend, double alpha,
    const double *x, const int *ind, double beta, double *y, int incy);

void ublas_bspdotab_row(int nb, enum blas_trans_type blocktransA,
    int Mb, int k, double alpha,  int ibegin, int iend,
    const double *val, const int *indx,
    const double *B, int ldB, double beta, double *C, int ldC);

void ublas_bspdotab_col(
    int nb, enum blas_trans_type blocktransA,
    int Mb, int k, double alpha,
    int ibegin, int iend, const double *val, const int *indx,
    const double *B, int ldB,
    double beta,
    double *C, int ldC);

#endif
