import java.io.*;

public class RandomSubMatrix {

  /**
    Open a file and fill it with random numbers
   */
  RandomSubMatrix(int height, int width, String fileName1, String fileName2) {

    double[][] tempArray = new double[height][width];

    try {
      PrintWriter out1 = new PrintWriter(new FileOutputStream(fileName1));
      PrintWriter out2 = new PrintWriter(new FileOutputStream(fileName2));

      // print the size
      out1.println(height + " " + width);
      out2.println(height/2 + " " + width/2);

      for (int i = height/4; i < 3 * height / 4; i++) {
	for (int j = width/4; j < 3 * width / 4; j++) {
	  tempArray[i][j] = (20 * (Math.random() - .5));
	  out2.println(tempArray[i][j]);
	}
      }
      out2.flush();
      out2.close();

      for (int i = 0; i < height; i++) 
	for (int j = 0; j < width; j++)
	  out1.println(tempArray[i][j]);

      out1.flush();
      out1.close();



    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public static void main(String[] args) {
    
    RandomSubMatrix r = new RandomSubMatrix(Integer.valueOf(args[0]).intValue(),
					    Integer.valueOf(args[1]).intValue(), args[2], args[3]);

  }
}
